Loading...
Searching...
No Matches
QGpgME::EncryptJob Class Referenceabstract

An abstract base class for asynchronous encrypters. More...

`#include <encryptjob.h>`

Inheritance diagram for QGpgME::EncryptJob:
[legend]
Collaboration diagram for QGpgME::EncryptJob:
[legend]

## Signals

void | result (const GpgME::EncryptionResult &result, const QByteArray &cipherText, const QString &auditLogAsHtml=QString(), const GpgME::Error &auditLogError=GpgME::Error())
Signals inherited from QGpgME::Job
void | jobProgress (int current, int total)
void | rawProgress (const QString &what, int type, int current, int total)
QGPGME_DEPRECATED void | progress (const QString &what, int current, int total)
void | done ()

## Public Member Functions

void | setFileName (const QString &fileName)
QString | fileName () const
void | setInputEncoding (GpgME::Data::Encoding)
GpgME::Data::Encoding | inputEncoding () const
void | setRecipients (const std::vector< GpgME::Key > &recipients)
std::vector< GpgME::Key > | recipients () const
void | setInputFile (const QString &path)
QString | inputFile () const
void | setOutputFile (const QString &path)
QString | outputFile () const
void | setEncryptionFlags (GpgME::Context::EncryptionFlags flags)
GpgME::Context::EncryptionFlags | encryptionFlags () const
virtual GpgME::Error | start (const std::vector< GpgME::Key > &recipients, const QByteArray &plainText, bool alwaysTrust=false)=0
virtual void | start (const std::vector< GpgME::Key > &recipients, const std::shared_ptr< QIODevice > &plainText, const std::shared_ptr< QIODevice > &cipherText=std::shared_ptr< QIODevice >(), bool alwaysTrust=false)=0
virtual GpgME::EncryptionResult | exec (const std::vector< GpgME::Key > &recipients, const QByteArray &plainText, bool alwaysTrust, QByteArray &cipherText)=0
virtual void | setOutputIsBase64Encoded (bool)=0
virtual void | start (const std::vector< GpgME::Key > &recipients, const std::shared_ptr< QIODevice > &plainText, const std::shared_ptr< QIODevice > &cipherText=std::shared_ptr< QIODevice >(), const GpgME::Context::EncryptionFlags flags=GpgME::Context::None)=0
virtual GpgME::EncryptionResult | exec (const std::vector< GpgME::Key > &recipients, const QByteArray &plainText, const GpgME::Context::EncryptionFlags flags, QByteArray &cipherText)=0
Public Member Functions inherited from QGpgME::Job
virtual QString | auditLogAsHtml () const
virtual GpgME::Error | auditLogError () const
bool | isAuditLogSupported () const
GpgME::Error | startIt ()
void | startNow ()

## Protected Member Functions

| EncryptJob (std::unique_ptr< EncryptJobPrivate >, QObject *parent)
Protected Member Functions inherited from QGpgME::Job
| Job (std::unique_ptr< JobPrivate >, QObject *parent)
| Job (QObject *parent)

## Additional Inherited Members

Public Slots inherited from QGpgME::Job
virtual void | slotCancel ()=0
Static Public Member Functions inherited from QGpgME::Job
static GpgME::Context * | context (Job *job)
Protected Attributes inherited from QGpgME::Job
const std::unique_ptr< JobPrivate > | d_ptr

## Detailed Description

An abstract base class for asynchronous encrypters.

To use a EncryptJob, first obtain an instance from the CryptoBackend implementation, connect the progress() and result() signals to suitable slots and then start the encryption with a call to start(). This call might fail, in which case the EncryptJob instance will have scheduled it's own destruction with a call to QObject::deleteLater().

Alternatively, the job can be started with startIt() after setting an input file and an output file and, optionally, recipients or flags. If the job is started this way then the backend reads the input and writes the output directly from/to the specified input file and output file. In this case the cipherText value of the result signal will always be empty. This direct IO mode is currently only supported for OpenPGP. Note that startIt() does not schedule the job's destruction if starting the job failed.

After result() is emitted, the EncryptJob will schedule it's own destruction by calling QObject::deleteLater().

## Member Function Documentation

## exec()

virtual GpgME::EncryptionResult QGpgME::EncryptJob::exec | ( | const std::vector< GpgME::Key > & | recipients,
|  | const QByteArray & | plainText,
|  | const GpgME::Context::EncryptionFlags | flags,
|  | QByteArray & | cipherText )

pure virtual

Like exec but with an additional argument for EncryptionFlags for more flexibility.

Implemented in QGpgME::QGpgMEEncryptJob.

## setEncryptionFlags()

void EncryptJob::setEncryptionFlags | ( | GpgME::Context::EncryptionFlags | flags | ) |

Sets the flags to use for encryption.

Defaults to `EncryptFile`.

Used if the job is started with startIt(). The `EncryptFile` flag is always assumed set.

## setFileName()

void EncryptJob::setFileName | ( | const QString & | fileName | ) |

Sets the file name to embed in the encryption result.

This is only used if one of the start() functions is used.

## setInputEncoding()

void EncryptJob::setInputEncoding | ( | GpgME::Data::Encoding | inputEncoding | ) |

Sets the encoding of the plaintext.

This is only used if one of the start() functions is used.

## setInputFile()

void EncryptJob::setInputFile | ( | const QString & | path | ) |

Sets the path of the file to encrypt.

Used if the job is started with startIt().

## setOutputFile()

void EncryptJob::setOutputFile | ( | const QString & | path | ) |

Sets the path of the file to write the encryption result to.

Used if the job is started with startIt().

Note
  If a file with this path exists, then the job will fail, i.e. you need to delete an existing file that shall be overwritten before you start the job.

## setOutputIsBase64Encoded()

virtual void QGpgME::EncryptJob::setOutputIsBase64Encoded | ( | bool |  | ) |

pure virtual

This is a hack to request BASE64 output (instead of whatever comes out normally).

Implemented in QGpgME::QGpgMEEncryptJob.

## setRecipients()

void EncryptJob::setRecipients | ( | const std::vector< GpgME::Key > & | recipients | ) |

Sets the keys to use for encryption.

Used if the job is started with startIt().

## start() [1/3]

virtual GpgME::Error QGpgME::EncryptJob::start | ( | const std::vector< GpgME::Key > & | recipients,
|  | const QByteArray & | plainText,
|  | bool | alwaysTrust = false )

pure virtual

Starts the encryption operation. recipients is the a list of keys to encrypt plainText to. Empty (null) keys are ignored. If recipients is empty, performs symmetric (passphrase) encryption.

If alwaysTrust is true, validity checking for the keys will not be performed, but full validity assumed for all keys without further checks.

Implemented in QGpgME::QGpgMEEncryptJob.

## start() [2/3]

virtual void QGpgME::EncryptJob::start | ( | const std::vector< GpgME::Key > & | recipients,
|  | const std::shared_ptr< QIODevice > & | plainText,
|  | const std::shared_ptr< QIODevice > & | cipherText = std::shared_ptr< QIODevice >(),
|  | bool | alwaysTrust = false )

pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

If cipherText is non-null, the ciphertext is written there. Otherwise, it will be delivered in the second argument of result().

Implemented in QGpgME::QGpgMEEncryptJob.

## start() [3/3]

virtual void QGpgME::EncryptJob::start | ( | const std::vector< GpgME::Key > & | recipients,
|  | const std::shared_ptr< QIODevice > & | plainText,
|  | const std::shared_ptr< QIODevice > & | cipherText = std::shared_ptr< QIODevice >(),
|  | const GpgME::Context::EncryptionFlags | flags = GpgME::Context::None )

pure virtual

Like start but with an additional argument for EncryptionFlags for more flexibility.

Implemented in QGpgME::QGpgMEEncryptJob.

The documentation for this class was generated from the following files:

- encryptjob.h
- encryptjob.cpp